#pragma once

/// <summary>
///         
///   .     
/// ,      (  
///   ).
/// </summary>
struct CPerfCounter  
{
	static double s_freq;
    inline static double QueryFreq()
    {
        //VLDEnable();
        LONGLONG freq = 0;
        QueryPerformanceFrequency((PLARGE_INTEGER)&freq);
        return (double)freq;
    }


	LONGLONG _start;
	double _lastDelta;

	CPerfCounter() {
		_start = 0;
		_lastDelta = 0;
	}

	double get_LastDelta() {
		return _lastDelta;
	}

	/// <summary>
	///    .
	/// </summary>
	void Start() {
		this->_start = 0;
		QueryPerformanceCounter((PLARGE_INTEGER)&_start);
	}

	/// <summary>
	///         .
	///      .
	/// </summary>
	/// <returns>      
	/// .     .</returns>
	double Finish() {
		LONGLONG finish = 0;
		QueryPerformanceCounter((PLARGE_INTEGER)&finish);
		this->_lastDelta = (double)(finish - this->_start) /s_freq;
		this->_start = finish;
		return this->_lastDelta;
	}

	/// <summary>
	///    PerformanceCounter  
	/// </summary>
	double get_Current() {
		LONGLONG curr = 0;
		QueryPerformanceCounter((PLARGE_INTEGER)&curr);
		return (double)curr /s_freq;
	}

	/// <summary>
	///          
	///  .
	///    .
	/// </summary>
	double FromStart() { 
		LONGLONG finish = 0;
		QueryPerformanceCounter((PLARGE_INTEGER)&finish);
		return this->_lastDelta = (double)(finish - _start) /s_freq;
	}

};

double __declspec(selectany) CPerfCounter::s_freq = CPerfCounter::QueryFreq();



